/**
 * Created by Kevin on 03.04.2016.
 */


var windowWidth = window.innerWidth;
var windowHeight = window.innerHeight;

var rtime;
var timeout = false;

var screenresX = 0;
var screenresY = 0;

var renderer;
var stage;
var dreiecke = [];
var rowAmmount;
var mainId = 0;
setTimeout(setupScreen, 500);
setTimeout(renderLoop, 700);

window.onresize = function () {
    windowWidth = window.innerWidth;
    windowHeight = window.innerHeight;
    rtime = new Date();
    if (timeout === false) {
        timeout = true;
        setTimeout(resizeend, 700);
    }
};

function resizeend() {
    if (new Date() - rtime < 700) {
        setTimeout(resizeend, 700);
    } else {
        timeout = false;

        console.log("resized");

        if (screenresX != window.screen.width && screenresY != window.screen.height) {
            document.getElementById("backgroundEffect").style.opacity = 0;
            document.getElementById("backgroundOverlay").style.opacity = .6;
            setTimeout(setupScreen, 3000);
        }
    }
}

function setupScreen() {
    screenresX = window.screen.width;
    screenresY = window.screen.height;
    delete window.renderer;
    renderer = PIXI.autoDetectRenderer(screenresX, screenresY, {transparent: true});
    document.getElementById("backgroundEffect").innerHTML = "";
    document.getElementById("backgroundEffect").appendChild(renderer.view);
    renderer.view.position = "fixed";
    stage = new PIXI.Container();

    drawDreiecke(screenresX, screenresY);

    document.getElementById("backgroundEffect").style.opacity = 1;
    document.getElementById("backgroundOverlay").style.opacity = 0;

}

function drawDreiecke(screenresX, screenresY) {
    rowAmmount = 0;
    dreiecke = [];
    var orientation = "Up";
    for (var y = 0; y < screenresY + 31; y += 30) {
        for (var x = 0; (x < screenresX + 31) || (x % 2 == 0); x += 15) {
            var dreieck = new Dreieck(x, y, orientation, dreiecke.length);
            dreiecke.push(dreieck);
            if (orientation == "Up") {
                orientation = "Down";
            } else {
                orientation = "Up";
            }
            if (y == 0) {
                rowAmmount++;
            }
        }
    }
}

function renderLoop() {
    renderer.render(stage);
    setTimeout(renderLoop, 20);
}

window.onmousemove = function (event) {
    var mousePos = new PIXI.Point(event.clientX, event.clientY);
    for (var id = 0; id < dreiecke.length; id++) {
        dreiecke[id].calculateState(mousePos);
    }
};

function Dreieck(middleX, middleY, orientation, id) {
    var state = "Reset";
    var pushDirection = "N";
    var pushVor = true;
    var stateChanged = false;
    var makingAnimation = false;
    var dreieck = new PIXI.Graphics();
    dreieck.beginFill(0x000000);
    if (orientation == "Up") {
        dreieck.moveTo(middleX + 14, middleY + 14);
        dreieck.lineTo(middleX - 14, middleY + 14);
        dreieck.lineTo(middleX, middleY - 14);
    } else if (orientation == "Down") {
        dreieck.moveTo(middleX - 14, middleY - 14);
        dreieck.lineTo(middleX + 14, middleY - 14);
        dreieck.lineTo(middleX, middleY + 14);
    }
    dreieck.endFill();
    dreieck.alpha = 0.6;
    stage.addChild(dreieck);

    this.calculateState = function (mousePos) {
        if (dreieck.containsPoint(mousePos)) {
            if (state != "Main") {
                state = "Main";
                stateChanged = true;
                mainId = id;
            }
        } else if (id == mainId - 1 || id == mainId - 2 || id == mainId + 1 || id == mainId + 2 || id == mainId - rowAmmount || id == mainId - rowAmmount - 1 || id == mainId - rowAmmount + 1 || id == mainId + rowAmmount || id == mainId + rowAmmount - 1 || id == mainId + rowAmmount + 1 ||
            (orientation == "Up" && (id == mainId - rowAmmount - 2 || id == mainId - rowAmmount + 2)) || (orientation == "Down" && (id == mainId + rowAmmount - 2 || id == mainId + rowAmmount + 2))) {
            if (state != "Neighbour") {
                state = "Neighbour";
                stateChanged = true;

                //this.dopush();
            }
        } else {
            if (state != "Reset") {
                state = "Reset";
                stateChanged = true;
            }
        }
        if (stateChanged && !makingAnimation) {
            makeAnimation();
            stateChanged = false;
        }
    };

    function makeAnimation() {
        makingAnimation = true;
        var needAnotherLoop = false;

        if (state == "Reset") {
            if (dreieck.alpha < 0.6) {
                dreieck.alpha += 0.1;
                needAnotherLoop = true;
            }
        } else if (state == "Neighbour") {
            if (dreieck.alpha > 0.3) {
                dreieck.alpha -= 0.1;
                needAnotherLoop = true;
            }
            if (dreieck.alpha < 0.3) {
                dreieck.alpha += 0.1;
                needAnotherLoop = true;
            }
        } else if (state == "Main") {
            if (dreieck.alpha > 0) {
                dreieck.alpha -= 0.1;
                needAnotherLoop = true;
            }
        }
        if (needAnotherLoop) {
            setTimeout(makeAnimation, 20);
        } else {
            makingAnimation = false;
        }
    }

    this.dopush = function () {
        var needAnotherPush = false;
        if (pushDirection == "N") {
            if (pushVor) {
                dreieck.y -= 1;
                if (dreieck.y == -2) {
                    pushVor = !pushVor;
                }
            } else if (dreieck.y < 0) {
                dreieck.y += 1;
            } else {
                pushVor = !pushVor;
            }
        } else if (pushDirection == "S") {
            if (pushVor) {
                dreieck.y += 1;
                if (dreieck.y == 2) {
                    pushVor = !pushVor;
                }
            } else if (dreieck.y > 0) {
                dreieck.y -= 1;
            } else {
                pushVor = !pushVor;
            }
        } else if (pushDirection == "NW") {
            if (pushDirection) {
                if (dreieck.y < 2) {
                    dreieck.y -= 1;
                }
            } else if (dreieck.y < 0) {
                dreieck.y += 1;
            }
        } else if (pushDirection == "NO") {
            if (pushDirection) {
                if (dreieck.y < 2) {
                    dreieck.y -= 1;
                }
            } else if (dreieck.y < 0) {
                dreieck.y += 1;
            }
        } else if (pushDirection == "SW") {
            if (pushDirection) {
                if (dreieck.y < 2) {
                    dreieck.y -= 1;
                }
            } else if (dreieck.y < 0) {
                dreieck.y += 1;
            }
        } else if (pushDirection == "SO") {
            if (pushDirection) {
                if (dreieck.y < 2) {
                    dreieck.y -= 1;
                }
            } else if (dreieck.y < 0) {
                dreieck.y += 1;
            }
        }
        if (needAnotherPush) {
            setTimeout(this.dopush, 500);
        }
    }
}